% --------------------------------------------------------
% Initialisierungsskript fr Simulink Beobachter
%   - Drehwinkel
%   - Winkelgeschwindigkeit
%   - unbekanntes Lastmoment
% --------------------------------------------------------

clear all
close all
clc

p  = 4;
F  = 0.175;
Bm = 0.001;
J  = 0.8e-3;

kt = 1.5*(p/2)*F;
ke = (p/2)/J;

%
% x(t) = [            Drehwinkel;
%          Winkelgeschwindigkeit;
%         unbekanntes Lastmoment];
%
% u(t) = momentbildender Statorstrom
%
% y(t) = Drehwinkel
%

A = [0      1    0;
     0  -Bm/J  -ke;
     0      0    0];

B = [    0;
     ke*kt;
         0];

C = [1 0 0;
     0 0 0;
     0 0 0];

D = [0;
     0;
     0];

 
sys = ss(A, B, C, D);

disp(' ')
disp('Anzahl der nicht beobachtbaren Zustnde')
Ob = obsv(sys.a, sys.c);
unob = length(A)-rank(Ob)

% Pole fr Beobachter 
polc = [-1000.0;
        -1000.1;
        -1000.2];

% Rckfhrvektor fr Beobachtungsfehler
L  = place(sys.a', sys.c', polc).';

% Matrizen fr Beobachter
Ao =  sys.a-L*sys.c;
Bo = [sys.b-L*sys.d L];
Co = eye(length(C));
Do = zeros(size(Bo));

% neue Eingangsmatrix B (Eingang mit Strung)
B = [    0  0;
     ke*kt  0;
         0  1];

% neue Durchgangsmatrix D
D = zeros(3,2);
